#!/bin/sh
#  kaNet: network manager for Kanotix
#  hrb 08.02.06 v.kanet-0.01-01
#  start the tcl shell \
exec wish "$0" "$@" "$HOME"
#
#**************************************************************************************
#  proc.doPon {} toggles the conn-flag and outputs the 'pon/poff'-command
#**************************************************************************************
proc doPon { } {
    global conn ic0 pom0
    set conn0 $conn ; set conn [expr !$conn] ;# toggle the value
    if { $conn } {  ;#  connect
         exec pon dsl-provider ; $ic0 configure -bg green ; $pom0 configure -bg green
    }    else    {  ;# disconnect
         exec poff -a ;      $ic0 configure -bg yellow ; $pom0 configure -bg yellow }
  } ;#  end proc doPon
#
#**************************************************************************************
#  proc.doCompress {} saves the xy-position, removes the big window and shows the icon
#**************************************************************************************
proc doCompress { } {
    global ic big bpos ipos
    set bgeo [ winfo geometry $big ] ; set igeo [ winfo geometry $ic ]
    regsub -all {x} $bgeo " " bgeox ; regsub -all {\+} $bgeox " " bgeol
    regsub -all {x} $igeo " " igeox ; regsub -all {\+} $igeox " " igeol
    set bw [lindex $bgeol 0] ; set bh [lindex $bgeol 1]
    set iw [lindex $igeol 0] ; set ih [lindex $igeol 1]
    if { $iw <= 1 } { set iw 45 } ; if { $ih <= 1 } { set ih 24 }
#
    set bx [expr [lindex $bgeol 2] -4] ; set by [expr [lindex $bgeol 3] - 24]
    set ix [expr $bx + $bw - $iw] ;  set iy [expr $by + $bh - $ih + 24]
    set bpos "+$bx+$by" ; set ipos "+$ix+$iy" ; saveConf
#puts "kan36; bgeol= *$bgeol*, igeol= *$igeol*"
#puts "kan37; ix,iy= *$ix*$iy, bpos= *$bpos*, ipos= *$ipos*"
    wm geometry $big $bpos ; wm geometry $ic $ipos ;# position both windows
    wm deiconify $ic ; wm withdraw $big ; update idletasks ;# remove big, show small
  } ;#  end proc doCompress
#
#**************************************************************************************
#  proc.doExpand displays the big window and iconifies the icon window
#**************************************************************************************
proc doExpand { } {
    global ic big
    wm deiconify $big ; wm withdraw $ic ; update idletasks
  } ;# proc.iconfield
#
#**************************************************************************************
#  proc.doLang displays the messages: englisch / deutsch
#**************************************************************************************
proc doLang { } {
    global lang msen msde 
    global ms1 ms2 ms3 ms4 ms5 ms6 ms7 ms8 ms9 ms10 ms11 ms12 ms13 ms14 ms15 ms16
    if { $lang == {en} } { set cnt 1 ; foreach ms $msen { set ms$cnt $ms ; incr cnt }
    }    else          { set cnt 1 ; foreach ms $msde { set ms$cnt $ms ; incr cnt } }
  } ;# proc.doLang
#
#**************************************************************************************
#  proc.dohelp displays the help text
#**************************************************************************************
proc dohelp { } {
    global bpos lang msen msde ms7 ms8 ms9 ms10 ms11 ms12 ms13 ms14 ms15 m16
    set wh .hlp  ; toplevel $wh ; wm geometry $wh $bpos ;  wm title $wh $ms7
    set wt $wh.t1 ; labelframe $wt
    label $wt.m8  -textvariable ms8  ; label $wt.m9  -textvariable ms9
    label $wt.m10 -textvariable ms10 ; label $wt.m11 -textvariable ms11
    label $wt.m12 -textvariable ms12 ; label $wt.m13 -textvariable ms13
    label $wt.m14 -textvariable ms14 ; label $wt.m15 -textvariable ms15
    label $wt.m16 -textvariable ms16
    set whb $wh.f2 ; labelframe $whb
    button $whb.b1 -textvariable ms4  -width 9 -command "destroy $wh"
    pack $wt.m8 $wt.m9 $wt.m10 $wt.m11 $wt.m12 $wt.m13 $wt.m14 $wt.m15 $wt.m16 \
         -anchor w ;  pack $whb.b1 ; pack $wt $whb
  } ;# proc.dohelp
#
#**************************************************************************************
#  proc.saveConf {} writes the config-file kanet.conf
#**************************************************************************************
proc saveConf {} {
    global kacon pVersion bpos ipos aconn acomp lang
    if { ![catch { open $kacon w } fil ] } {
      catch { puts  $fil "confVersion    = $pVersion" }
      catch { puts  $fil "xy pos-big     = $bpos" }
      catch { puts  $fil "xy pos-icon    = $ipos" }
      catch { puts  $fil "connect @start = $aconn" }
      catch { puts  $fil "compress@start = $acomp" }
      catch { puts  $fil "language       = $lang" }
      catch { close $fil } } ;# end if open ok
  } ;# end proc. saveConfig
#
#**************************************************************************************
#  Main window: configure + position
#**************************************************************************************
    set pVersion "kanet-0.01-01" ; set cVersion "kanet-unknown";# prog+conf versions
    set aconn 0 ; set acomp 0 ; set lang en ; set bpos +787+557 ; set ipos +928+693
    set conn 0  ; set dkacon "$argv/.kanet" ; set kacon $dkacon/kanet.conf
#
#  read config file
    if { ![file isdirectory $dkacon] } { catch [exec mkdir -p $dkacon] }
    if { ![catch {open $kacon} fil] } {
      while {1} { gets $fil curl ; if { [eof $fil] } { break } ; lappend lconf $curl }
#     read VersionCode from kanet.conf; if version ok: read kanet.conf completely
      catch { set cVersion [string trim [string range [lindex $lconf 0] 17 end ]] }
      if { [string range $cVersion 0 9] == [string range $pVersion 0 9] } {
        set bpos  [string trim [string range [lindex $lconf 1] 17 end ]]
        set ipos  [string trim [string range [lindex $lconf 2] 17 end ]]
        set aconn [string trim [string range [lindex $lconf 3] 17 end ]]
        set acomp [string trim [string range [lindex $lconf 4] 17 end ]]
        set lang  [string trim [string range [lindex $lconf 5] 17 end ]]
      } ; # end if version ok
    } ;# if config file ok
#
#  main window:
    set big . ;  wm title $big $pVersion ; wm geometry $big $bpos
    set conf .conf ; labelframe $conf
    set msen [list "connect on start" "compress on start" "Compress" "Exit" "Save" \
        "Help" "$pVersion help text" \
        "kaNet supports convenient connection to the net." \
        "After a click on the coloured kaNet button, kaNet outputs either" \
        "'pon dsl-provider' or 'poff -a', and the button changes its colour" \
        "to green or to yellow, respectively." \
        "A right-click on the kaNet-button compresses the window to that button,"\
        "another right-click restores the extended window." \
        "The kaNet window can be positioned on the desktop by drag 'n drop," \
        "and will re-assume its display mode after re-start or re-boot," \
        "provided that the window has been compressed at least once in the new position." ]
#
    set msde [list "Einwahl bei Start" "Einklappen bei Start" "Einklappen" \
        "Beenden" "Speichern" "Hilfe" "$pVersion Hilfe-Text" \
        "kaNet untersttzt die bequeme Einwahl ins Netz." \
        "Nach einem Mausklick auf den farbigen kaNet-Knopf sendet kaNet entweder" \
        "'pon dsl-provider' oder 'poff -a'," \
        "und der Knopf ndert seine Farbe auf grn bzw. gelb." \
        "Rechts-Klick auf den kaNet-Knopf klappt das kaNet-Fenster ein," \
        "ein zweiter Rechts-Klick klappt es wieder aus." \
        "Das kaNet-Fenster lsst sich auf dem Bildschirm mit gedrckter Maustaste" \
        "positionieren und behlt nach Neustart bzw. Systemstart seine Position," \
        "sofern das Fenster an der neuen Position mindestens einmal eingeklappt wurde." ]
#
    if { $lang == {en} } { set cnt 1 ; foreach ms $msen { set ms$cnt $ms ; incr cnt }
    }    else          { set cnt 1 ; foreach ms $msde { set ms$cnt $ms ; incr cnt } }

    set f0 $conf.f0 ; frame $f0 ;# checkbutton part of big window
    checkbutton $f0.b1 -textvariable ms1 -variable aconn
    checkbutton $f0.b2 -textvariable ms2 -variable acomp
    radiobutton $f0.r1 -text "english" -variable lang -value en -command doLang
    radiobutton $f0.r2 -text "deutsch" -variable lang -value de -command doLang
    pack  $f0.b1 $f0.b2 $f0.r1 $f0.r2 -anchor w
#
    set but $conf.but ; labelframe $but ;# button part of big window
    set but1 $but.f1 ; frame $but1 ; set but2 $but.f2 ; frame $but2
    button $but1.b0 -textvariable ms3 -width 9 -command "doCompress ; saveConf"
    button $but1.b1 -textvariable ms4 -width 9 -command "saveConf ; destroy . ; return"
    button $but2.b0 -textvariable ms5 -width 9 -command "saveConf"
    button $but2.b1 -textvariable ms6 -width 9 -command "dohelp"
    pack  $but1.b1 $but1.b0 -side right ; pack  $but2.b1 $but2.b0 -side right
    pack $but1 $but2 -side bottom ; 
    pack $but -side bottom ; pack $f0 -side bottom -padx 18 -anchor w
#
    set pom .pom ; labelframe $pom
    set pom0 $pom.m0 ; label $pom0 -text "kaNet" -bg yellow ; pack $pom0
    bind $pom0 <Button-1> doPon ;  bind $pom0 <Button-3> doCompress
    pack  $pom $conf -side bottom -anchor e
#
#  small mini-window (icon-like) for pon/poff
    set ic .ic ; toplevel $ic ; wm overrideredirect $ic 1 ; wm withdraw $ic
    wm geometry $ic $ipos ; set icf $ic.f0 ; labelframe $icf
    set ic0 $icf.m0 ; label $ic0 -text "kaNet" -bg yellow ; pack $ic0 ; pack $icf
    bind $ic0 <Button-1> doPon ;  bind $ic0 <Button-3> doExpand
#
    if { $aconn } { doPon } ;# connect/compress on start
    if { $acomp } { wm deiconify $ic ; wm withdraw $big ; update idletasks }
#################        ** end proc.kaNet **        ##################################
#**************************************************************************************
